org.cpsolver.studentsct.online.expectations

## Class NeverOverExpected

- java.lang.Object
- - org.cpsolver.studentsct.online.expectations.NeverOverExpected

- All Implemented Interfaces:
    OverExpectedCriterion

      public class NeverOverExpected
      extends Object
      implements OverExpectedCriterion

  A section is never over-expected.
  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.cpsolver.studentsct.online.expectations.OverExpectedCriterion

      `OverExpectedCriterion.HasContext`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `NeverOverExpected(DataProperties config)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Integer` | `getExpected(int sectionLimit, double expectedSpace)` Expected space, for printing purposes
    `double` | `getOverExpected(Assignment<Request,Enrollment> assignment, Section section, Request request)` Expectation penalty, to be minimized

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### NeverOverExpected

          public NeverOverExpected(DataProperties config)

  - ### Method Detail

    - #### getOverExpected

          public double getOverExpected(Assignment<Request,Enrollment> assignment,
                                        Section section,
                                        Request request)

      Description copied from interface: `OverExpectedCriterion`
      Expectation penalty, to be minimized
      Specified by:
        `getOverExpected` in interface `OverExpectedCriterion`
      Parameters:
        `assignment` - current assignment
        `section` - section in question
        `request` - student course request
      Returns:
        expectation penalty (typically 1.0 / number of subparts when over-expected, 0.0 otherwise)

    - #### getExpected

          public Integer getExpected(int sectionLimit,
                                     double expectedSpace)

      Description copied from interface: `OverExpectedCriterion`
      Expected space, for printing purposes
      Specified by:
        `getExpected` in interface `OverExpectedCriterion`
      Parameters:
        `sectionLimit` - section limit, see `Section.getLimit()`
        `expectedSpace` - expectation, see `Section.getSpaceExpected()`
      Returns:
        expected space to be printed (null if there are no expectations)